package ch.phoenix.oss.quarkus.commons.audit;

import jakarta.enterprise.inject.spi.CDI;
import org.hibernate.envers.RevisionListener;

public class AuditRevisionListener implements RevisionListener {

    @Override
    public void newRevision(Object revisionEntity) {
        var provider = CDI.current().select(RevisionContextProvider.class).get();

        var rev = (Revision) revisionEntity;
        rev.actor = provider.getActor();
        rev.traceId = provider.getTraceId();
        rev.spanId = provider.getSpanId();
        rev.requestId = provider.getRequestId();
        rev.clientIp = provider.getClientIp();
        rev.hostName = provider.getHostName();
    }
}
