package ch.phoenix.oss.quarkus.commons.audit;

import io.quarkus.hibernate.orm.panache.PanacheEntityBase;
import jakarta.persistence.*;
import java.time.Instant;
import java.util.Objects;
import org.hibernate.envers.RevisionEntity;
import org.hibernate.envers.RevisionNumber;
import org.hibernate.envers.RevisionTimestamp;

@Entity
@Table(name = "revinfo")
@RevisionEntity(AuditRevisionListener.class)
public class Revision extends PanacheEntityBase {

    @Id
    @GeneratedValue
    @RevisionNumber
    public long rev;

    @RevisionTimestamp
    @Column(nullable = false, updatable = false)
    public Instant timestamp;

    @Column(updatable = false)
    public String actor;

    @Column(updatable = false)
    public String traceId;

    @Column(updatable = false)
    public String spanId;

    @Column(updatable = false)
    public String requestId;

    @Column(updatable = false)
    public String clientIp;

    @Column(updatable = false)
    public String hostName;

    @Override
    public boolean equals(Object o) {
        if (!(o instanceof Revision that)) return false;
        return rev == that.rev;
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(rev);
    }

    @Override
    public String toString() {
        return "Revision{rev=" + rev + '}';
    }
}
