package ch.phoenix.oss.quarkus.commons.audit;

import static org.assertj.core.api.AssertionsForInterfaceTypes.assertThat;
import static org.mockito.Mockito.mockStatic;

import io.quarkus.test.junit.QuarkusTest;
import jakarta.inject.Inject;
import java.net.InetAddress;
import java.net.UnknownHostException;
import org.junit.jupiter.api.Test;

@QuarkusTest
class DefaultRevisionContextProviderTest {

    @Inject
    DefaultRevisionContextProvider underTest;

    @Test
    void getHostName() {
        assertThat(underTest.getHostName()).isNotBlank();
    }

    @Test
    void getHostNameWhenUnknown() {
        try (var inetMock = mockStatic(InetAddress.class)) {
            inetMock.when(InetAddress::getLocalHost).thenThrow(new UnknownHostException("simulated failure"));

            assertThat(underTest.getHostName()).isEqualTo("unknown");
        }
    }
}
