package ch.phoenix.oss.quarkus.commons.audit;

import static org.assertj.core.api.Assertions.assertThat;

import io.quarkus.test.junit.QuarkusTest;
import org.junit.jupiter.api.Test;

@QuarkusTest
class RevisionTest {

    @Test
    void testEquals() {
        var r1 = new Revision();
        r1.rev = 1;

        var r2 = new Revision();
        r2.rev = 1;

        var r3 = new Revision();
        r3.rev = 2;

        assertThat(r1)
                .as("Revisions equality should should match expected value")
                .isEqualTo(r1)
                .isEqualTo(r2)
                .isNotEqualTo(r3)
                .isNotEqualTo(new Object());
    }

    @Test
    void testHashCode() {
        var r1 = new Revision();
        r1.rev = 123;

        var r2 = new Revision();
        r2.rev = 123;

        var r3 = new Revision();
        r3.rev = 2;

        assertThat(r1.hashCode()).isEqualTo(123).isEqualTo(r2.hashCode()).isNotEqualTo(r3.hashCode());
    }

    @Test
    void testToString() {
        var rev = new Revision();
        rev.rev = 1;

        assertThat(rev).as("Revision's toString should match expected value").hasToString("Revision{rev=1}");
    }
}
