create sequence revinfo_seq start with 1 increment by 50;
create sequence test_entity_seq start with 1 increment by 50;

create table revinfo
(
    rev       bigint                      not null,
    timestamp timestamp(6) with time zone not null,
    actor     varchar(255),
    spanId    varchar(255),
    traceId   varchar(255),
    requestId varchar(255),
    clientIp  varchar(255),
    hostName  varchar(255),
    primary key (rev)
);

create table test_entity
(

    id            bigint primary key not null,
    something     varchar(255),
    createdAt     timestamp(6) with time zone,
    lastUpdatedAt timestamp(6) with time zone
);

create table test_entity_aud
(
    revtype   smallint,
    rev       bigint not null,
    revend    bigint,
    id        bigint not null,
    something varchar(255),
    primary key (rev, id)
);

alter table if exists test_entity_aud
    add constraint fk_rev__revinfo_rev
        foreign key (rev)
            references revinfo;


alter table if exists test_entity_aud
    add constraint fk_revend__revinfo_rev
        foreign key (revend)
            references revinfo;

