CREATE OR REPLACE FUNCTION trg_test_entity_aud_apply_rev()
    RETURNS TRIGGER
    LANGUAGE plpgsql
AS $func$
DECLARE
    ts TIMESTAMP;
BEGIN
    -- fetch the exact revision timestamp from revinfo
    SELECT r.timestamp
    INTO ts
    FROM revinfo r
    WHERE r.rev = NEW.rev;

    -- only set created_at once, when still NULL
    UPDATE test_entity
    SET createdAt      = ts
    WHERE id = NEW.id
      AND createdAt IS NULL;

    -- always bump last_updated_at
    UPDATE test_entity
    SET lastUpdatedAt = ts
    WHERE id = NEW.id;

    RETURN NULL;
END;
$func$;

DROP TRIGGER IF EXISTS trg_test_entity_aud_after_insert
    ON test_entity_aud;

CREATE TRIGGER trg_test_entity_aud_after_insert
    AFTER INSERT ON test_entity_aud
    FOR EACH ROW
EXECUTE FUNCTION trg_test_entity_aud_apply_rev();
