package ch.phoenix.oss.quarkus.commons.clock;

import io.quarkus.arc.DefaultBean;
import jakarta.enterprise.context.ApplicationScoped;
import java.time.*;

@DefaultBean
@ApplicationScoped
class ClockServiceImpl implements ClockService {

    private final Clock clock;

    ClockServiceImpl(Clock clock) {
        this.clock = clock;
    }

    @Override
    public Instant instant() {
        return clock.instant();
    }

    @Override
    public long currentTimeMillis() {
        return clock.millis();
    }

    @Override
    public LocalDate localDate() {
        return LocalDate.now(clock);
    }

    @Override
    public LocalDateTime localDateTime() {
        return LocalDateTime.now(clock);
    }

    @Override
    public ZonedDateTime zonedDateTime() {
        return ZonedDateTime.now(clock);
    }
}
