package ch.phoenix.oss.quarkus.commons.random;

import java.util.Random;

/**
 * Provides Random instances that can be used for any purpose,
 * such as generating random numbers or strings.
 */
public interface RandomProvider {

    /**
     * Get a new Random instance.
     *
     * @return The Random instance
     * @throws IllegalStateException If the Random instance cannot be created
     */
    Random get();
}
