package ch.phoenix.oss.quarkus.commons.random;

import io.quarkus.arc.DefaultBean;
import jakarta.enterprise.context.ApplicationScoped;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.util.Random;

@DefaultBean
@ApplicationScoped
class RandomProviderImpl implements RandomProvider {

    @Override
    public Random get() {
        try {
            return SecureRandom.getInstanceStrong();
        } catch (NoSuchAlgorithmException e) {
            throw new IllegalStateException("Unable to obtain strong SecureRandom instance", e);
        }
    }
}
