package ch.phoenix.oss.quarkus.commons.uuid;

import java.util.Random;
import java.util.UUID;

public interface UUIDGenerator {

    UUID NAMESPACE_DNS = UUID.fromString("6ba7b810-9dad-11d1-80b4-00c04fd430c8");
    UUID NAMESPACE_URL = UUID.fromString("6ba7b811-9dad-11d1-80b4-00c04fd430c8");
    UUID NAMESPACE_OID = UUID.fromString("6ba7b812-9dad-11d1-80b4-00c04fd430c8");
    UUID NAMESPACE_X500 = UUID.fromString("6ba7b814-9dad-11d1-80b4-00c04fd430c8");

    UUID generateV4();

    UUID generateV4(Random random);

    UUID generateV5(String name);

    UUID generateV5(UUID namespace, String name);

    default UUID generateV5WithDNSNamespace(String name) {
        return generateV5(NAMESPACE_DNS, name);
    }

    default UUID generateV5WithURLNamespace(String name) {
        return generateV5(NAMESPACE_URL, name);
    }

    default UUID generateV5WithOIDNamespace(String name) {
        return generateV5(NAMESPACE_OID, name);
    }

    default UUID generateV5WithX500Namespace(String name) {
        return generateV5(NAMESPACE_X500, name);
    }
}
