package ch.phoenix.oss.quarkus.commons.uuid;

import com.fasterxml.uuid.Generators;
import io.quarkus.arc.DefaultBean;
import jakarta.enterprise.context.ApplicationScoped;
import java.util.Random;
import java.util.UUID;

@DefaultBean
@ApplicationScoped
class UUIDGeneratorImpl implements UUIDGenerator {

    @Override
    public UUID generateV4() {
        return Generators.randomBasedGenerator().generate();
    }

    @Override
    public UUID generateV4(Random random) {
        return Generators.randomBasedGenerator(random).generate();
    }

    @Override
    public UUID generateV5(String name) {
        return Generators.nameBasedGenerator().generate(name);
    }

    @Override
    public UUID generateV5(UUID namespace, String name) {
        return Generators.nameBasedGenerator(namespace).generate(name);
    }
}
